package com.monnit.mine.SampleMineApplication;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;

import com.monnit.mine.MonnitMineAPI.Sensor;

public class FindSensorPopup extends JFrame {

    public static Sensor sens;

    public static JPanel main;
    public static JPanel title;
    public static JLabel titleLabel;
    public static JLabel type;
    public static JPanel config1;
    public static JPanel reportInterval;
    public static JLabel reportIntervalLabel;
    public static JTextField reportIntervalField;
    public static JPanel linkInterval;
    public static JLabel linkIntervalLabel;
    public static JTextField linkIntervalField;
    public static JButton updateConfig1;
    public static JPanel config2;
    public static JPanel retryCount;
    public static JLabel retryCountLabel;
    public static JTextField retryCountField;
    public static JPanel recoveryPanel;
    public static JLabel recoveryLabel;
    public static JTextField recoveryField;
    public static JButton updateConfig2;

    public static Dimension mainDim = new Dimension(250, 350);
    public static Dimension titleDim = new Dimension(200, 70);
    public static Dimension rowDim = new Dimension(200, 25);
    public static Dimension halfRow = new Dimension(100, 25);

    public FindSensorPopup(Sensor s) {
        super("Sensor");
        this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        this.setPreferredSize(mainDim);

        sens = s;
        main = new JPanel();
        main.setLayout(new BoxLayout(main, BoxLayout.Y_AXIS));
        this.add(main);

        createTitle();
        createConfig1();
        createConfig2();

        main.setPreferredSize(mainDim);
        main.add(title);
        main.add(config1);
        main.add(config2);

        this.pack();
        this.setVisible(true);
    }

    public static void createTitle() {
        title = new JPanel();
        title.setLayout(new BoxLayout(title, BoxLayout.Y_AXIS));
        title.setPreferredSize(titleDim);

        titleLabel = new JLabel("SensorID: " + sens.getSensorID());
        titleLabel.setPreferredSize(rowDim);
        type = new JLabel(sens.getMonnitApplication().name());
        type.setPreferredSize(rowDim);

        title.add(titleLabel);
        title.add(type);
    }

    public static void createConfig1() {
        config1 = new JPanel();
        config1.setLayout(new BoxLayout(config1, BoxLayout.Y_AXIS));

        reportInterval = new JPanel();
        reportInterval.setPreferredSize(rowDim);
        reportIntervalLabel = new JLabel("Report Interval: ");
        reportIntervalField = new JTextField("" + sens.getReportInterval());
        reportIntervalField.setPreferredSize(halfRow);
        reportInterval.add(reportIntervalLabel);
        reportInterval.add(reportIntervalField);
        linkInterval = new JPanel();
        linkInterval.setPreferredSize(rowDim);
        linkIntervalLabel = new JLabel("Link Interval: ");
        linkIntervalField = new JTextField("" + sens.getTransmitIntervalLink());
        linkIntervalField.setPreferredSize(halfRow);
        linkInterval.add(linkIntervalLabel);
        linkInterval.add(linkIntervalField);
        updateConfig1 = new JButton("Update");
        updateConfig1.setPreferredSize(rowDim);
        updateConfig1.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent arg0) {
                try {
                    sens.UpdateReportInterval(getReportInterval());
                } catch (InterruptedException e1) {
                    // TODO Auto-generated catch block
                    e1.printStackTrace();
                }
                try {
                    sens.UpdateLinkInterval(getLinkIntervalField());
                } catch (InterruptedException e1) {
                    // TODO Auto-generated catch block
                    e1.printStackTrace();
                }
                GUIListenerFunctions.print("Updated Sensor Config 1.");
            }
        });

        config1.add(reportInterval);
        config1.add(linkInterval);
        config1.add(updateConfig1);
    }

    public static int getLinkIntervalField() throws InterruptedException {
        try {
            return Integer.parseInt(linkIntervalField.getText());
        } catch (Exception e) {
            GUIListenerFunctions.print("Invalid Link Interval. " + e.toString());
            linkIntervalField.setText("" + sens.getTransmitIntervalLink());
            return sens.getTransmitIntervalLink();
        }
    }

    public static double getReportInterval() throws InterruptedException {
        try {
            return Double.parseDouble(reportIntervalField.getText());
        } catch (Exception e) {
            GUIListenerFunctions.print("Invalid Report Interval. " + e.toString());
            reportIntervalField.setText("" + sens.getReportInterval());
            return sens.getReportInterval();
        }
    }

    public static void createConfig2() {
        config2 = new JPanel();
        config2.setLayout(new BoxLayout(config2, BoxLayout.Y_AXIS));

        retryCount = new JPanel();
        retryCount.setPreferredSize(rowDim);
        retryCountLabel = new JLabel("Retry Count: ");
        //retryCountLabel.setPreferredSize(halfRow);
        retryCountField = new JTextField("" + sens.getRetryCount());
        retryCountField.setPreferredSize(halfRow);
        retryCount.add(retryCountLabel);
        retryCount.add(retryCountField);
        recoveryPanel = new JPanel();
        recoveryPanel.setPreferredSize(rowDim);
        recoveryLabel = new JLabel("Recovery: ");
        //recoveryLabel.setPreferredSize(halfRow);
        recoveryField = new JTextField("" + sens.getRecovery());
        recoveryField.setPreferredSize(halfRow);
        recoveryPanel.add(recoveryLabel);
        recoveryPanel.add(recoveryField);
        updateConfig2 = new JButton("Update");
        updateConfig2.setPreferredSize(rowDim);
        updateConfig2.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent arg0) {
                try {
                    sens.UpdateRetryCount(getRetryCount());
                } catch (InterruptedException e1) {
                    // TODO Auto-generated catch block
                    e1.printStackTrace();
                }
                try {
                    sens.UpdateRecoveryCount(getRecovery());
                } catch (InterruptedException e1) {
                    // TODO Auto-generated catch block
                    e1.printStackTrace();
                }
                GUIListenerFunctions.print("Updated Sensor Config 2.");
            }
        });

        config2.add(retryCount);
        config2.add(recoveryPanel);
        config2.add(updateConfig2);
    }

    public static int getRetryCount() throws InterruptedException {
        try {
            return Integer.parseInt(retryCountField.getText());
        } catch (Exception e) {
            GUIListenerFunctions.print("Invalid Retry Count.");
            retryCountField.setText("" + sens.getRetryCount());
            return sens.getRetryCount();
        }
    }

    public static int getRecovery() throws InterruptedException {
        try {
            return Integer.parseInt(recoveryField.getText());
        } catch (Exception e) {
            GUIListenerFunctions.print("Invalid Recovery.");
            recoveryField.setText("" + sens.getRecovery());
            return sens.getRecovery();
        }
    }
}
