package com.monnit.mine.SampleMineApplication;

import java.net.*;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.List;

import com.monnit.mine.BaseApplication._ApplicationBase;
import com.monnit.mine.BaseApplication.ExtensionMethods.Extensions;
import com.monnit.mine.BaseApplication.applicationclasses.AttentionBase;
import com.monnit.mine.MonnitMineAPI.Gateway;
import com.monnit.mine.MonnitMineAPI.MineServer;
import com.monnit.mine.MonnitMineAPI.Sensor;
import com.monnit.mine.MonnitMineAPI.enums.eFirmwareGeneration;
import com.monnit.mine.MonnitMineAPI.enums.eGatewayType;
import com.monnit.mine.MonnitMineAPI.enums.eMineListenerProtocol;
import com.monnit.mine.MonnitMineAPI.enums.eSensorApplication;
import java.util.Map;

public class GUIListenerFunctions {

    private static MineServer _Server;

    public static synchronized void print(String s) {
//		if(!lock) {
//			lock = true;
        gui.println(s);
        System.out.println(s);
        /*lock = false;}
        else {
			try {
            Thread.sleep(100);
        } catch (Exception e) {
            e.printStackTrace();
        }
        print(s);
    }*/
    }

    public static void startButtonPressed() throws Exception {
        int port = getPort();
        if (port < 1) {
            gui.println("Invalid Port Number.");
            return;
        }
        eMineListenerProtocol Protocol;
        try {
            Protocol = eMineListenerProtocol.valueOf(gui.protocolDropdown.getSelectedItem().toString());
        } catch (Exception e) {
            print("Invalid Protocol");
            return;
        }

        InetAddress ip = InetAddress.getByName(gui.ipDropdown.getSelectedItem().toString());                                             //stringToByteIP(gui.ipDropdown.getSelectedItem().toString()));

        _Server = new MineServer(Protocol, ip, port);
        print("Constructed Server.");
        _Server.StartServer();
        print("Server started.");
       

        if (_Server.addGatewayDataProcessingHandler(new GatewayMessageHandler())) {
            print("Added GatewayHandler.");
        } else {
            print("Failed to add handler.");
        }
        if (_Server.addSensorDataProcessingHandler(new SensorMessageHandler())) {
            print("Added SensorHandler.");
        } else {
            print("Failed to add handler.");
        }
        if (_Server.addExceptionProcessingHandler(new ExceptionHandler())) {
            print("Added ExceptionHandler.");
        } else {
            print("Failed to add handler.");
        }
        if (_Server.addPersistSensorHandler(new PersistSensorHandler())) {
            print("Added PersistSensorHandler.");
        } else {
            print("Failed to add handler.");
        }
        if (_Server.addPersistGatewayHandler(new PersistGatewayHandler())) {
            print("Added PersistGatewayHandler.");
        } else {
            print("Failed to add handler.");
        }
        if (_Server.addUnknownGatewayHandler(new UnknownGatewayHandler())) {
            print("Added UnknownGatewayHandler.");
        } else {
            print("Failed to add handler.");
        }
        
        ResponseHandler responseHandler = new ResponseHandler();
        _Server.addGatewayResponseHandler(responseHandler);
        
//        if (_Server.addUnknownSensorHandler(new UnknownSensorHandler())) {
//            print("Added UnknownSensorHandler.");
//        } else {
//            print("Failed to add handler");
//        }
//        

           //Example of implementing your own Function (Gateways)
//        if (_Server.assignExternalDeviceStorageHandler(new ExternalDeviceStorageHandler())) {
//            print("Overwrote FindGatewayHandler.");
//        } else {
//            print("Failed to add handler.");
//        }
        

        ///////////////////////////////////////////////////////////
        //         Ad-hoc sensors and gateways
        ///////////////////////////////////////////////////////////
        /*
		 * Gateway ethGate;
		 //ethGate = new Gateway(113374,eGatewayType.CGW3,"1.3.2.0","2.5.0.0","52.25.237.205",4000);
		 //ethGate.ServerHostAddress = "200.118.116.87";
		 //ethGate.Port = 3001;
                 //ethGate.IsDirty = true;
         */
       //Gateway ethGate = new Gateway(113374, eGatewayType.CGW3GPRSINT, "1.3.2.0", "2.4.0.6", "52.25.237.205", 4000);
      //  ethGate.ServerHostAddress = "u1.sensorsgateway.com";
       // ethGate.Port = 3000;
      //  ethGate.ServerHostAddress2 = "u1.sensorsgateway.com";
     //   ethGate.Port2 = 3000;
      //  ethGate.setIsDirty(true);
      //  List<Sensor> sensList = new CopyOnWriteArrayList<Sensor>();
        //Gateway usbGate = new Gateway(
        //		9596,
        //		eGatewayType.USB,
        //		3000
        //		);

     //   sensList.add(new Sensor(
      //          94129,
      //          eSensorApplication.SmartRanger,
      //          "2.3.0.0"
      //  ));
        //_Server.RegisterGateway(ethGate);
//		for(Sensor s : sensList) {
//			_Server.RegisterSensor(ethGate.getGatewayID(), s);
//		}

        print("Finished all inits");
        print(MineServer.getVersion());
        
    }

    private static int getPort() {
        try {
            return Integer.parseInt(gui.portField.getText());
        } catch (Exception e) {
            return -1;
        }
    }

    public static void RegisterGateway() throws Exception {
        int gid = getGid();
        if (gid > 0) {
            eGatewayType egt = eGatewayType.valueOf(gui.gType.getSelectedItem().toString());
            int port = getPort();
            Gateway gate = new Gateway(
                    gid,
                    egt,
                    "3.4.1.3",
                    "1.0.1.0",
                    "0.0.0.0",
                    port
            );
            gate.IsDirty = false;
            _Server.RegisterGateway(gate);

           // gate.UpdateReportInterval(.5);            
            print("Gateway " + gid + " registered.");
        }
    }

    public static void RemoveGateway() throws InterruptedException {
        int gid = getGid();
        if (gid > 0) {
            _Server.RemoveGateway(gid);
            print("Gateway " + gid + " removed.");
        }
    }

    public static Sensor FindSensorBySensorID(int sid) throws InterruptedException {
        Sensor sens = _Server.FindSensor(sid);
        return sens;
    }

    public static void registerSensor() throws Exception {
        int sid = getSid();
        if (sid > 0) {           
            eSensorApplication esa = null;
            
            for (Map.Entry<Integer,String> entry : eSensorApplication.getStringValues().entrySet())
            {         
                if (gui.sType.getSelectedItem().toString().equals(entry.getValue()))
                {
                    esa = eSensorApplication.getEnum(entry.getKey());
                    break;
                }
            }
            
            eFirmwareGeneration platform = eFirmwareGeneration.valueOf(gui.genType.getSelectedItem().toString());
            
            Sensor sens = new Sensor(sid, esa, "2.5.4.3", platform);
            try {
                int gid = getGid();
                if (gid > 0) {
                    _Server.RegisterSensor(gid, sens);
                    print("Sensor " + sid + " registered.");
                } else {
                    print("Invalid GatewayID.");
                }

                
            } catch (Exception e) {
                System.out.println(e.toString());
                GUIListenerFunctions.print("Failed to register sensor.");
            }
        }
    }
    
    public static void removeSensor() throws InterruptedException, Exception {
        int sid = getSid();
        if (sid > 0) {
            _Server.RemoveSensor(sid);
           print("Sensor " + sid + " has been removed.");
        }
 
    }
   
    static int queID = 1;
    public static void SendMsgToLocalAlert() throws InterruptedException, Exception {
        int sid = getSid();
     if (sid > 0) {
     Sensor sens = _Server.FindSensor(sid);
//     AttentionBase.SendMessage(sens, sid, "0123456789", queID, true, true, true, true, true, 2017, 1, 30, 16, 10, "abcdefghijklmnopqrstuvwxyz");
     queID++;
     }
    }

    public static void FindSensor() throws InterruptedException {
        int sid = getSid();
        if (sid > 0) {
            Sensor sens = _Server.FindSensor(sid);
            FindSensorPopup pop = new FindSensorPopup(sens);
        }
    }

    public static void FindGateway() {
        int gid = getGid();
        if (gid > 0) {
            Gateway gate = _Server.FindGateway(gid);
            FindGatewayPopup pop = new FindGatewayPopup(gate);
        }
    }

    public static int getSid() {
        int sid;
        try {
            sid = Integer.parseInt(gui.sid.getText());
        } catch (Exception e) {
            gui.println(e.toString());
            gui.println("Invalid SensorID");
            return -1;
        }
        return sid;
    }

    public static int getGid() {
        int gid;
        try {
            gid = Integer.parseInt(gui.gid.getText());
        } catch (Exception e) {
            gui.println("Invalid GatewayID.");
            return -1;
        }
        return gid;
    }

    public static byte[] stringToByteIP(String ip) {
        byte[] bip = new byte[4];
        String[] iparray = ip.split("\\.");
        for (int i = 0; i < bip.length; i++) {
            bip[i] = (byte) Integer.parseInt(iparray[i]);
        }
        return bip;
    }

    public static void ReformNetwork() {
        Gateway gate = _Server.FindGateway(getGid());
        if (gate != null) {
            gate.ReformNetwork();
            GUIListenerFunctions.print("Reform pending.");
        } else {
            GUIListenerFunctions.print("Gateway does not exist.");
        }
    }
    
    public static void PointToiMonnit()
    {
        Gateway gate = _Server.FindGateway(getGid());
         if (gate != null) {
            
             gate.ServerHostAddress = "u1.sensorsgateway.com";
             gate.Port = 3000;
             gate.setIsDirty(true);
            
            GUIListenerFunctions.print("update pending.");
        } else {
            GUIListenerFunctions.print("Gateway does not exist.");
        }
    }

    public static void SendSensorList() {
        Gateway gate = _Server.FindGateway(getGid());
        Extensions.debug("This doesn't do anything (yet).", 20);
    }
    
//    public static void SetSensorToDefault()
//    {
//        try{
//            Sensor sens = _Server.FindSensor(getSid());
//            sens.SetSensorToDefault();
//            GUIListenerFunctions.print("update pending.");
//        }
//        catch(Exception ex)
//        {
//        GUIListenerFunctions.print("Sensor does not exist.");
//        }
//    }
}
