package com.monnit.mine.SampleMineApplication;

import com.monnit.mine.MonnitMineAPI.enums.eFirmwareGeneration;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;
import java.awt.*;

import com.monnit.mine.MonnitMineAPI.enums.eGatewayType;
import com.monnit.mine.MonnitMineAPI.enums.eSensorApplication;
import java.net.InetAddress;

public class gui {

    public static JFrame frame;
    public static JPanel panel; //Only thing directly inside the frame
    public static JPanel northPanel;
    public static JPanel ipPanel;
    public static JLabel ipLabel;
    public static JComboBox ipDropdown;
    public static String[] ipAddresses;
    public static JPanel protocolPanel;
    public static JLabel protocolLabel;
    public static JComboBox protocolDropdown;
    public static String[] protocols;
    public static JPanel portPanel;
    public static JLabel portLabel;
    public static JTextField portField;
    public static JButton startListenButton;
    public static JButton clearButton;
    public static JPanel centerPanel;
    public static JPanel GatePanel;
    public static JPanel GateBtnContainer;
    public static JPanel GateBtnPanel1;
    public static JPanel GateBtnPanel2;
    public static JPanel gidPanel;
    public static JLabel gidLabel;
    public static JTextField gid;
    public static JComboBox gType;
    public static String[] gTypes;
    public static JButton gRegisterButton;
    public static JButton gFindButton;
    public static JButton gRemoveButton;
    public static JButton gReformButton;
    public static JButton gPointButton;
    //public static JButton gSensorListButton;
    public static JPanel SensPanel;
    public static JPanel SensBtnContainer;
    public static JPanel SensBtnPanel1;
    public static JPanel SensBtnPanel2;
    public static JPanel sidPanel;
    public static JLabel sidLabel;
    public static JTextField sid;
    public static JComboBox sType;
    public static JComboBox genType;
    public static String[] sTypes;
    public static JButton sRegisterButton;
    public static JButton sFindButton;
    public static JButton sRemoveButton;
    public static JButton sUpdateHeartBeatButton;
    public static JButton sSetToDefaultButton;
//    public static JButton sSendMsgToLocalAlert;
    public static JScrollPane outputScroll;
    public static JTextArea outputArea;
    public static GridBagConstraints constraints;

    public static Dimension panelDimension = new Dimension(640, 700);
    public static Dimension outputAreaDimension = new Dimension(200, 400);
    public static Dimension dedim = new Dimension(150, 10);
    public static Dimension gsDim = new Dimension(200, 400);
    public static Dimension nDim = new Dimension(400, 40);

    public static void create() {
        try {
            frame = new JFrame("Mine Sample Application");
            frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

            //initializing early to prevent printing exceptions
            outputArea = new JTextArea();

            panel = new JPanel(new GridBagLayout());
            constraints = new GridBagConstraints();
            constraints.fill = GridBagConstraints.BOTH;
            constraints.weightx = 1;
            constraints.weighty = 1;
            frame.add(panel);

            createNorth();
            createGate();
            createSens();
            
            outputArea.setEditable(false);
            outputArea.setLineWrap(true);
            outputScroll = new JScrollPane(outputArea);
            constraints.gridx = 0;
            constraints.gridy = 10;
            constraints.gridwidth = 10;
//            constraints.gridheight = 50;
            constraints.ipady = 250;
            constraints.insets = new Insets(10, 10, 10, 10);
            panel.add(outputScroll, constraints);
//            outputScroll.setPreferredSize(outputAreaDimension);
//            panel.add(outputScroll);
            frame.pack();
            frame.setVisible(true);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private static void createNorth() {
        try {
            ipLabel = new JLabel("IP Address");
            constraints.gridx = 0;
            constraints.gridy = 0;
            constraints.insets = new Insets(10, 10, 0, 10);
            panel.add(ipLabel, constraints);
            
            ipAddresses = new String[]{"0.0.0.0", InetAddress.getLocalHost().getHostAddress()};
            ipDropdown = initiateComboBox(ipAddresses);
//            ipDropdown.setPreferredSize(dedim);
            constraints.gridx = 0;
            constraints.gridy = 1;
            constraints.gridwidth = 2;
            constraints.insets = new Insets(0, 10, 10, 10);
            panel.add(ipDropdown, constraints);
               
            protocolLabel = new JLabel("Protocol");
            constraints.gridx = 2;
            constraints.gridy = 0;
            constraints.gridwidth = 1;
            constraints.insets = new Insets(10, 10, 0, 10);
            panel.add(protocolLabel, constraints);
            
            protocols = new String[]{"TCPAndUDP", "TCP", "UDP"};
            protocolDropdown = initiateComboBox(protocols);
            constraints.gridx = 2;
            constraints.gridy = 1;
            constraints.gridwidth = 2;
            constraints.insets = new Insets(0, 10, 10, 10);
            panel.add(protocolDropdown, constraints);

            portLabel = new JLabel("Port");
            constraints.gridx = 4;
            constraints.gridy = 0;
            constraints.gridwidth = 1;
            constraints.insets = new Insets(10, 10, 0, 10);
            panel.add(portLabel, constraints);
            
            portField = new JTextField("3000");
            constraints.gridx = 4;
            constraints.gridy = 1;
            constraints.gridwidth = 2;
            constraints.insets = new Insets(0, 10, 10, 10);
            panel.add(portField, constraints);

            startListenButton = new JButton("Start Listening");            
            startListenButton.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    try {
                        GUIListenerFunctions.startButtonPressed();
                    } catch (Exception e1) {
                        GUIListenerFunctions.print(e1.toString());
                    }
                }
            });
            constraints.gridx = 6;
            constraints.gridy = 0;
            constraints.gridwidth = 2;
            constraints.gridheight = 2;
            constraints.insets = new Insets(10, 10, 10, 10);
            panel.add(startListenButton, constraints);
            
            clearButton = new JButton("Clear Output");            
            clearButton.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    clearOutput();
                }
            });
            constraints.gridx = 8;
            constraints.gridy = 0;
            constraints.gridwidth = 2;
            constraints.gridheight = 2;
            constraints.insets = new Insets(10, 10, 10, 10);
            panel.add(clearButton, constraints);
            
            // Reset used constraint values to Default
            constraints.gridx = 0;
            constraints.gridy = 0;
            constraints.gridwidth = 1;
            constraints.gridheight = 1;
            constraints.insets = new Insets(0, 0, 0, 0);
            
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private static void createGate() {
        try {
            gidLabel = new JLabel("GatewayID");
            constraints.gridx = 0;
            constraints.gridy = 3;
            constraints.insets = new Insets(0, 10, 0, 0);
            panel.add(gidLabel, constraints);
            
            gid = new JTextField();
            constraints.gridx = 1;
            constraints.gridy = 3;
            constraints.gridwidth = 3;
            constraints.insets = new Insets(0, 0, 0, 0);
            panel.add(gid, constraints);

            gType = initiateComboBox(eGatewayType.toValueArray());
            constraints.gridx = 0;
            constraints.gridy = 4;
            constraints.gridwidth = 4;
            constraints.insets = new Insets(10, 10, 0, 0);
            panel.add(gType, constraints);

            gRegisterButton = new JButton("Register");
            gRegisterButton.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    try {
                        GUIListenerFunctions.RegisterGateway();
                    } catch (Exception e1) {
                        GUIListenerFunctions.print("You must start the server before registering a gateway.");
                    }
                }
            });
            constraints.gridx = 1;
            constraints.gridy = 5;
            constraints.gridwidth = 1;
            constraints.insets = new Insets(10, 0, 0, 0);
            panel.add(gRegisterButton, constraints);
            
            gFindButton = new JButton("Find");
            gFindButton.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    GUIListenerFunctions.FindGateway();
                }
            });
            constraints.gridx = 1;
            constraints.gridy = 6;
            constraints.gridwidth = 1;
            constraints.insets = new Insets(5, 0, 0, 0);
            panel.add(gFindButton, constraints);
            
            gRemoveButton = new JButton("Remove");
            gRemoveButton.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    try {
                        GUIListenerFunctions.RemoveGateway();
                    } catch (InterruptedException e1) {
                        // TODO Auto-generated catch block
                        e1.printStackTrace();
                    }
                }
            });
            constraints.gridx = 1;
            constraints.gridy = 7;
            constraints.gridwidth = 1;
            constraints.insets = new Insets(5, 0, 0, 0);
            panel.add(gRemoveButton, constraints);
            
            gReformButton = new JButton("Reform");
            gReformButton.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent arg0) {
                    GUIListenerFunctions.ReformNetwork();
                }
            });
            constraints.gridx = 1;
            constraints.gridy = 8;
            constraints.gridwidth = 1;
            constraints.insets = new Insets(5, 0, 0, 0);
            panel.add(gReformButton, constraints);
            
            gPointButton = new JButton("Point to iMonnit");
            gPointButton.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent arg0) {
                    GUIListenerFunctions.PointToiMonnit();
                }
            });
            constraints.gridx = 1;
            constraints.gridy = 9;
            constraints.gridwidth = 1;
            constraints.insets = new Insets(5, 0, 0, 0);
            panel.add(gPointButton, constraints);
            
            // Reset used constraint values to Default
            constraints.gridx = 0;
            constraints.gridy = 0;
            constraints.gridwidth = 1;
            constraints.gridheight = 1;
            constraints.insets = new Insets(0, 0, 0, 0);
            
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private static void createSens() {
        try {
            sidLabel = new JLabel("SensorID");
            constraints.gridx = 5;
            constraints.gridy = 3;
            constraints.insets = new Insets(0, 0, 0, 10);
            panel.add(sidLabel, constraints);
            
            sid = new JTextField();
            constraints.gridx = 6;
            constraints.gridy = 3;
            constraints.gridwidth = 4;
            constraints.insets = new Insets(0, 0, 0, 10);
            panel.add(sid, constraints);
            
            sType = initiateComboBox(eSensorApplication.toImplementedValueArray());
            constraints.gridx = 5;
            constraints.gridy = 4;
            constraints.gridwidth = 5;
            constraints.insets = new Insets(10, 0, 0, 10);
            panel.add(sType, constraints);
            
            genType = initiateComboBox(eFirmwareGeneration.toValueArray());
            constraints.gridx = 5;
            constraints.gridy = 5;
            constraints.gridwidth = 5;
            constraints.insets = new Insets(0, 0, 0, 10);
            panel.add(genType, constraints);
            
            sRegisterButton = new JButton("Register");
            sRegisterButton.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    try {
                        GUIListenerFunctions.registerSensor();
                    } catch (Exception e1) {
                        e1.printStackTrace();
                    }
                }
            });
            constraints.gridx = 6;
            constraints.gridy = 6;
            constraints.gridwidth = 2;
            constraints.insets = new Insets(10, 0, 0, 0);
            panel.add(sRegisterButton, constraints);
            
            sFindButton = new JButton("Find");
            sFindButton.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    try {
                        GUIListenerFunctions.FindSensor();
                    } catch (InterruptedException e1) {
                        // TODO Auto-generated catch block
                        e1.printStackTrace();
                    }
                }
            });
            constraints.gridx = 6;
            constraints.gridy = 7;
            constraints.gridwidth = 2;
            constraints.insets = new Insets(5, 0, 0, 0);
            panel.add(sFindButton, constraints);
            
            sRemoveButton = new JButton("Remove");
            sRemoveButton.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    try {
                        GUIListenerFunctions.removeSensor();
                    } catch (Exception e1) {
                        // TODO Auto-generated catch block
                        e1.printStackTrace();
                    }
                }
            });
            constraints.gridx = 6;
            constraints.gridy = 8;
            constraints.gridwidth = 2;
            constraints.insets = new Insets(5, 0, 0, 0);
            panel.add(sRemoveButton, constraints);            

            sUpdateHeartBeatButton = new JButton("Update");
            sUpdateHeartBeatButton.addActionListener(new ActionListener() {

                @Override
                public void actionPerformed(ActionEvent e) {
                    try {
                        UpdateTemperatureSensor uts = new UpdateTemperatureSensor();

                    } catch (Exception e1) {
                        // TODO Auto-generated catch block
                        e1.printStackTrace();
                    }
                }
            });
            constraints.gridx = 6;
            constraints.gridy = 9;
            constraints.gridwidth = 2;
            constraints.insets = new Insets(5, 0, 0, 0);
            panel.add(sUpdateHeartBeatButton, constraints);            
            
            // Reset used constraint values to Default
            constraints.gridx = 0;
            constraints.gridy = 0;
            constraints.gridwidth = 1;
            constraints.gridheight = 1;
            constraints.insets = new Insets(0, 0, 0, 0);
            
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private static JComboBox initiateComboBox(String[] strings) {
        return initiateComboBox(new JComboBox(), strings);
    }

    private static JComboBox initiateComboBox(JComboBox box, String[] strings) {
        for (String s : strings) {
            box.addItem(s);
        }
        return box;
    }

    public static void main(String[] args) {
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            @Override
            public void run() {
                try {
                    create();
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        });
    }

    public static String getOutput(String s) {
        int maxLines = 15;
        String currentOut = outputArea.getText();
        String[] lines = currentOut.split("\n");
        if (lines.length > maxLines) {
            StringBuilder sb = new StringBuilder();
            for (int i = 1; i < lines.length; i++) {
                sb.append(lines[i]);
                sb.append("\n");
            }
            currentOut = sb.toString();
        }
        currentOut += s + "\n";
        return currentOut;
    }

    public static void println(String s) {
        String data = outputArea.getText();
        data = s + "\n" + data;
        outputArea.setText(data);
    }

    public static void clearOutput() {
        outputArea.setText("");
    }
}
